<?php
$bucket="https://indeval-webdocs-publico-01122020.s3.amazonaws.com/";
$newimg = trim($_POST['newimg']);

$oldimg = trim($_POST['oldimg']);

$lang = $_GET['lang'];
$id = $_GET['id'];

$enviado = $_GET['enviado'];

$imagenDeFondo = trim($_POST['imagenDeFondo']);
$enlaceBoton = trim($_POST['enlaceBoton']);
$subtitulo = trim($_POST['subtitulo']);
$titulo = trim($_POST['titulo']);
$subtitulo = trim($_POST['subtitulo']);
$textoBoton = trim($_POST['textoBoton']);

$imagen = $oldimg;

    ////////////////SI HUBO CAMBIO DE IMAGEN

    if($newimg == 1){

        if (isset($_FILES['imagenDeFondo']) && $_FILES['imagenDeFondo']['error'] === UPLOAD_ERR_OK)
        {
            // get details of the uploaded file
            $fileTmpPath = $_FILES['imagenDeFondo']['tmp_name'];
            $fileName = $_FILES['imagenDeFondo']['name'];
            $fileSize = $_FILES['imagenDeFondo']['size'];
            $fileType = $_FILES['imagenDeFondo']['type'];
            $fileNameCmps = explode(".", $fileName);
            $fileExtension = strtolower(end($fileNameCmps));
        
            // sanitize file-name
            $newFileName = "Banner_".$id.'_'.$lang. '.' . $fileExtension;
    
            // check if file has one of the following extensions
            $allowedfileExtensions = array('jpg', 'gif', 'png', 'webp', 'svg');
        
            if (in_array($fileExtension, $allowedfileExtensions))
            {
            ///////////////SUBIR A AWS
                /// AWS API keys
                $aws_access_key_id = 'AKIA4EFX4JXF3WUEDZUY';
                $aws_secret_access_key = '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';
                // Bucket
                $bucket_name = 'indeval-webdocs-publico-01122020';
                // AWS region and Host Name (Host names are different for each AWS region)
                // As an example these are set to us-east-1 (US Standard)
                $aws_region = 'us-east-1';
                $host_name = $bucket_name . '.s3.amazonaws.com';

                // Server path where content is present. This is just an example
                //$content_path = $dest_path;
                $content = file_get_contents($fileTmpPath);

                // AWS file permissions
                $content_acl = 'public-read';

                // MIME type of file. Very important to set if you later plan to load the file from a S3 url in the browser (images, for example)
                $content_type = 'image/'.$fileExtension;

                if($content_type == 'image/svg' ){ $content_type = "image/svg+xml";}
                // Name of content on S3
                $content_title = 'img/inicio/banners/'.$newFileName;

                // Service name for S3
                $aws_service_name = 's3';

                // UTC timestamp and date
                $timestamp = gmdate('Ymd\THis\Z');
                $date = gmdate('Ymd');

                // HTTP request headers as key & value
                $request_headers = array();
                $request_headers['Content-Type'] = $content_type;
                $request_headers['Date'] = $timestamp;
                $request_headers['Host'] = $host_name;
                $request_headers['x-amz-acl'] = $content_acl;
                $request_headers['x-amz-content-sha256'] = hash('sha256', $content);
                // Sort it in ascending order
                ksort($request_headers);

                // Canonical headers
                $canonical_headers = [];
                foreach($request_headers as $key => $value) {
                    $canonical_headers[] = strtolower($key) . ":" . $value;
                }
                $canonical_headers = implode("\n", $canonical_headers);

                // Signed headers
                $signed_headers = [];
                foreach($request_headers as $key => $value) {
                    $signed_headers[] = strtolower($key);
                }
                $signed_headers = implode(";", $signed_headers);

                // Cannonical request 
                $canonical_request = [];
                $canonical_request[] = "PUT";
                $canonical_request[] = "/" . $content_title;
                $canonical_request[] = "";
                $canonical_request[] = $canonical_headers;
                $canonical_request[] = "";
                $canonical_request[] = $signed_headers;
                $canonical_request[] = hash('sha256', $content);
                $canonical_request = implode("\n", $canonical_request);
                $hashed_canonical_request = hash('sha256', $canonical_request);

                // AWS Scope
                $scope = [];
                $scope[] = $date;
                $scope[] = $aws_region;
                $scope[] = $aws_service_name;
                $scope[] = "aws4_request";

                // String to sign
                $string_to_sign = [];
                $string_to_sign[] = "AWS4-HMAC-SHA256"; 
                $string_to_sign[] = $timestamp; 
                $string_to_sign[] = implode('/', $scope);
                $string_to_sign[] = $hashed_canonical_request;
                $string_to_sign = implode("\n", $string_to_sign);

                // Signing key
                $kSecret = 'AWS4' . $aws_secret_access_key;
                $kDate = hash_hmac('sha256', $date, $kSecret, true);
                $kRegion = hash_hmac('sha256', $aws_region, $kDate, true);
                $kService = hash_hmac('sha256', $aws_service_name, $kRegion, true);
                $kSigning = hash_hmac('sha256', 'aws4_request', $kService, true);

                // Signature
                $signature = hash_hmac('sha256', $string_to_sign, $kSigning);

                // Authorization
                $authorization = [
                    'Credential=' . $aws_access_key_id . '/' . implode('/', $scope),
                    'SignedHeaders=' . $signed_headers,
                    'Signature=' . $signature
                ];
                $authorization = 'AWS4-HMAC-SHA256' . ' ' . implode( ',', $authorization);

                // Curl headers
                $curl_headers = [ 'Authorization: ' . $authorization ];
                foreach($request_headers as $key => $value) {
                    $curl_headers[] = $key . ": " . $value;
                }

                $url = 'https://' . $host_name . '/' . $content_title;
                $ch = curl_init($url);
                curl_setopt($ch, CURLOPT_HEADER, false);
                curl_setopt($ch, CURLOPT_HTTPHEADER, $curl_headers);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, false);
                curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
                curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
                curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PUT");
                curl_setopt($ch, CURLOPT_POSTFIELDS, $content);
                curl_exec($ch);
                $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
                if($http_code != 200){
                    echo "Error AWS";
                }
                if($http_code == 200){
                    $imagen = $bucket.$content_title;
                }
        
                
            }
            else
            {
                $message = '<p style="color:red; font-size:12px;">Extensión de imagen no válida. Verifica que tu archivo tenga uno de los siguientes formatos: ' . implode(', ', $allowedfileExtensions).'</p>';
                echo $message;
                exit();
            }
        }
        else
        {
            $message = '<p style="color:red; font-size:12px;">Error en subida de imagen:<br></p> ';
            $message .= '<p style="color:red; font-size:12px;">Error:' . $_FILES['imagenDeFondo']['error'].'</p>';
            echo $message;
            exit();
        }
        echo $message;
    }

    $curl = curl_init();

    if($lang == "en"){

        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://api-us-east-1.graphcms.com/v2/ckkxmrn6cw3ga01ywc1spb2qu/master',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',

            CURLOPT_POSTFIELDS =>'{"query":"mutation MyMutation {\\r\\n  updateBannerHome(data: {titulo: \\"'.$titulo.'\\", textoBoton: \\"'.$textoBoton.'\\", subtitulo: \\"'.$subtitulo.'\\", enlaceBoton: \\"'.$enlaceBoton.'\\",  enviadoRevision: \\"'.$enviado.'\\", imagenDeFondo: \\"'.$imagen.'\\"}, where: {id: \\"'.$id.'\\"}) {\\r\\n    id\\r\\n  }\\r\\n \\r\\n\\r\\n}\\r\\n","variables":{}}',
            CURLOPT_HTTPHEADER => array(
              'Content-Type: application/json',
              'Cookie: __cfduid=da2693cdfd39b7377a8a05e305da45b8f1613001694'
            ),
          ));

    }

    if($lang == "es"){
        curl_setopt_array($curl, array(
            CURLOPT_URL => 'https://api-us-east-1.graphcms.com/v2/ckkxmrn6cw3ga01ywc1spb2qu/master',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS =>'{"query":"mutation MyMutation {\\r\\n    updateBannerHome(data: {localizations: {update: {data: {enlaceBoton: \\"'.$enlaceBoton.'\\",  enviadoRevision: \\"'.$enviado.'\\", imagenDeFondo: \\"'.$imagen.'\\", subtitulo: \\"'.$subtitulo.'\\", textoBoton: \\"'.$textoBoton.'\\", titulo: \\"'.$titulo.'\\"}, locale: es_MX}}}, where: {id: \\"'.$id.'\\"}) {\\r\\n      id\\r\\n    }\\r\\n \\r\\n\\r\\n}\\r\\n","variables":{}}',
            CURLOPT_HTTPHEADER => array(
              'Content-Type: application/json',
              'Cookie: __cfduid=da2693cdfd39b7377a8a05e305da45b8f1613001694'
            ),
          ));

    }


    $response = curl_exec($curl);
    curl_close($curl);
    //echo $response;

    $jsonrespuesta = json_decode($response, true);
    $id = $jsonrespuesta['data']['updateBannerHome']['id'];

//echo $id;

  $sucess = "<p class='successmsg' style='text-transform:Capitalize;'>Banner actualizado correctamente</p>";
  $fail = "<p class='errormsg'>Falló la actualización..</p> ";


if(strlen($id)>10){

    echo $sucess;

    $string = $newstatus;
    $string = '"'.$string.'"';
    echo '<script>
        
        setTimeout(() => {
            $(".popUpEnlace").fadeOut();
        }, 1500);
    </script>';
}

else{
    echo $fail;
}

?>